bits 32

; This code generates 256 interrupt service routines
; - one for every interrupt! Since the CPU doesn't
; push an interrupt vector, this is the only way to
; provide a generic interface to interrupts.

extern interrupt_handlers
global isr_table
isr_table:
; here's a list of all the interrupt service routines (ISRs),
; generated by a preprocessor loop.
; we can't construct the IDT directly, because the addresses
; have to be split up and manipulated in a way which relocations
; can't cope with.
%assign n 0
%rep 256
    dd isr %+ n
%assign n n + 1
%endrep

; here are the actual ISRs, generated in a loop
%assign n 0
%rep 256
isr %+ n :           ; defines symbols isr0, isr1 etc.

%if n > 19           ; for non-exception handlers, push a fake error code
    push  dword 0    ; to make the stack uniform.
%endif
    
    pusha            ; push all general-purpose registers
    push  esp        ; push the stack pointer, so the interrupt handler can
                     ; use what we just pushed.

    push  dword n    ; push interrupt vector
    mov   eax,[interrupt_handlers + n * 4] ; get the handler address
    call  eax        ; call the handler
    add   esp,byte 8 ; clean up the stack after the call
    popa             ; pop all the registers we pushed with 'pusha'
    add   esp,byte 4 ; pop the error code
    sti
    iret             ; return from the interrupt
%assign n n + 1
%endrep

